Mulgara - Bug #133

Sporadic concurrent access in StringPoolSession
07/24/2008 07:27 AM - ronald -

Status: Closed Start date:

Priority: Urgent Due date:

Assignee: ronald - % Done: 0%
Category: Mulgara Estimated time: 0.00 hour
Target version:

Resolution: fixed

Description

Twice, on two different machines/os's/jdk's we've seen the
ItglinterpreterBeanUnitTest fail with the following stack trace:

org.mulgara.query.QueryException: Unable to load file:/Users/pag/src/mulgara/trunk/data/camera.n3
into rmi://10.0.1.198/serverl#itglmodel
.mulgara.resolver.DatabaseSession.execute (DatabaseSession. java:726)
.mulgara.resolver.DatabaseSession.setModel (DatabaseSession. java:562)
.mulgara.server.rmi.SessionWrapperRemoteSession.setModel (SessionWrapperRemoteSession

rmi.server.UnicastServerRef.dispatch (UnicastServerRef. java:305)

.rmi.transport.Transport$l.run(Transport.java:159)

java.security.AccessController.doPrivileged (Native Method)
rmi.transport.Transport.serviceCall (Transport.java:155)
rmi.transport.tcp.TCPTransport.handleMessages (TCPTransport. java:535)
rmi.transport.tcp.TCPTransport$ConnectionHandler.run0 (TCPTransport. java:790)
rmi.transport.tcp.TCPTransport$ConnectionHandler.run (TCPTransport.java:649)

jJava.util.concurrent.ThreadPoolExecutor$Worker.runTask (ThreadPoolExecutor. java:885)

java.util.concurrent.ThreadPoolExecutor$Worker.run (ThreadPoolExecutor. java:907)

java.lang.Thread.run (Thread. java:637)
rmi.transport.StreamRemoteCall.exceptionReceivedFromServer (StreamRemoteCall. java:25

.rmi.transport.StreamRemoteCall.executeCall (StreamRemoteCall. java:233)

rmi.server.UnicastRef.invoke (UnicastRef.java:142)
mulgara.server.rmi.RemoteSessionImpl_Stub.setModel (Unknown Source)
mulgara.server.rmi.RemoteSessionWrapperSession.setModel (RemoteSessionWrapperSession

query.operation.Load.doTx (Load. java:101)
query.operation.DatalnputTx.sendMarshalledData (DataInputTx.java:111)
query.operation.Load.execute (Load.java:79)

itgl.ItglInterpreterBean.load (ItglInterpreterBean. java:707)
itgl.ItglInterpreterBeanUnitTest.testLoadApi8 (ItglInterpreterBeanUnitTest. j
org.mulgara.query.MulgaraTransactionException: Transa
triggered

.mulgara.resolver.MulgaralnternalTransaction.implicitRollback (MulgaraInternalTransac

resolver.MulgaralInternalTransaction.execute (MulgaralnternalTransaction. java

resolver.DatabaseSession.execute (DatabaseSession. java:723)
resolver.DatabaseSession.setModel (DatabaseSession. java:562)
server.rmi.SessionWrapperRemoteSession.setModel (SessionWrapperRemoteSession
rmi.server.UnicastServerRef.dispatch (UnicastServerRef. java:305)
rmi.transport.Transport$l.run (Transport.java:159)
java.util.concurrent.ThreadPoolExecutor$Worker.runTask (ThreadPoolExecutor. java:885)

1/2




at java.util.concurrent.ThreadPoolExecutor$Worker.run (ThreadPoolExecutor. java:907)
at java.lang.Thread.run (Thread. java:637)
Caused by: org.mulgara.query.QueryException: org.mulgara.resolver.spi.ResolverException: Unable to
read input statements
at org.mulgara.resolver.store.StatementStoreResolver.modifyModel (StatementStoreResolver. ja

va:381)

at org.mulgara.resolver.InternalResolver.modifyModel (InternalResolver.java:164)

at org.mulgara.resolver.SetModelOperation.execute (SetModelOperation.java:153)

at org.mulgara.resolver.MulgaralnternalTransaction.execute (MulgaralnternalTransaction. java
:1623)

Caused by: org.mulgara.query.QueryException: org.mulgara.query.TuplesException: Exception while re

ading file:/Users/pag/src/mulgara/trunk/data/camera.n3
at org.mulgara.content.n3.Parser.checkForException (Parser.java:517)
at org.mulgara.content.n3.Parser.getTriple (Parser. java:539)
at org.mulgara.content.n3.N3Statements.next (N3Statements. java:389)
at org.mulgara.resolver.store.StatementStoreResolver.modifyModel (StatementStoreResolver. ja

va:353)

Caused by: java.lang.IllegalStateException: Concurrent Access of [[StringPoolSession]] Attempted
at org.mulgara.resolver.StringPoolSession.checkCurrentThread (StringPoolSession. java:787)
at org.mulgara.resolver.StringPoolSession.localizePersistent (StringPoolSession. java:207)
at org.mulgara.resolver.store.StatementStoreResolver.localizePersistent (StatementStoreReso

lver.java:451)
at org.mulgara.resolver.PersistentResolverSession.localize (PersistentResolverSession. java:

97)
at org.mulgara.content.n3.Parser.createBlankNode (Parser.java:453)
at org.mulgara.content.n3.Parser.getBlankNode (Parser. java:424)
at org.mulgara.content.n3.Parser.toNode (Parser.java:362)
at org.mulgara.content.n3.Parser.quad(Parser.java:272)
at com.hp.hpl.jena.n3.N3AntlrParser.emitQuad (N3AntlrParser. java:66)
at com.hp.hpl.jena.n3.N3AntlrParser.objectList (N3AntlrParser. java:738)
at com.hp.hpl.jena.n3.N3AntlrParser.propValue (N3AntlrParser.java:622)
at com.hp.hpl.jena.n3.N3AntlrParser.propertyList (N3AntlrParser. java:336)
at com.hp.hpl.jena.n3.N3AntlrParser.statementO (N3AntlrParser. java:287)
at com.hp.hpl.jena.n3.N3AntlrParser.statement (N3AntlrParser. java:204)
at com.hp.hpl.jena.n3.N3AntlrParser.document (N3AntlrParser.java:153)
at com.hp.hpl.jena.n3.N3Parser.parse (N3Parser.java:61)
at org.mulgara.content.n3.Parser.run(Parser.java:213)

Unfortunately, this has not been reproduceable. But interestingly
enough the stack trace was identical in both cases.

History

#1 - 07/25/2008 03:49 AM - ronald -

- Status changed from New to In Progress

Looks like this is easily reproducible under jdk 1.6.

#2 - 08/28/2008 12:54 AM - ronald -
- Status changed from In Progress to Closed

- Resolution set to fixed

Fixed in r1143.
https://code.mulgara.org/projects/mulgara/repository/3/revisions/1143
http://www.tcpdf.org

